" Vim syntax file
" Language:	Java
" Maintainer:	Jim Mitchell?
" Last change:	1997 April 20

" Remove any old syntax stuff hanging around
syntax clear

" keyword definitions
syntax keyword javaExternal       import native
syntax keyword javaError          cast const future generic goto inner outer rest
syntax keyword javaError          var byvalue operator
syntax keyword javaBranch         break continue
syntax keyword javaLabel          case default
syntax keyword javaConditional    if else switch
syntax keyword javaRepeat         while for do finally
syntax keyword javaBoolValue      true false
syntax keyword javaValue          null this super
"syntax keyword javaOperator       ++ -- + - ~ ! * / % << >> >>> > < >= <=
syntax keyword javaOperator       new instanceof "== != & ^ | && || 
"syntax keyword javaOperator       = *= /= %= += -= <<= >>= >>>= &= ^= |=
syntax keyword javaType           boolean char byte short int long float double
syntax keyword javaType           void
syntax keyword javaStatement      return
syntax keyword javaStructure      struct union enum typedef
syntax keyword javaStorageClass   static synchronized transient volatile final
syntax keyword javaExceptions     throw try catch
syntax keyword javaMethodDecl     synchronized throws
syntax keyword javaClassDecl      abstract extends class implements interface
syntax keyword javaScopeDecl      public protected private package


" match definitions. Note that I don't understand Vim regex's. These were
" cribbed from c.vim
syntax match   javaSpecial           contained "\\[0-9][0-9][0-9]\|\\."
syntax region  javaString            start=+"+  skip=+\\\\\|\\"+  end=+"+  contains javaSpecial
syntax match   javaCharacter         "'[^\\]'"
syntax match   javaSpecialCharacter  "'\\.'"
syntax match   javaNumber          "-\=\<[0-9]\+L\=\>\|0[xX][0-9a-fA-F]\+\>"
syntax match   javaCommentSkip     contained "^[ 	]*\*\($\|[ 	]\+\)"
syntax region  javaCommentString   contained start=+"+  skip=+\\\\\|\\"+  end=+"+ end=+\*/+S-1s-1 contains javaSpecial javaCommentSkip
syntax region  javaComment2String  contained start=+"+  skip=+\\\\\|\\"+  end=+$\|"+  contains javaSpecial
syntax region  javaComment         start="/\*"  end="\*/" contains javaCommentString javaCharacter javaNumber
syntax match   javaLineComment     "//.*" contains javaComment2String javaCharacter javaNumber 

syntax sync ccomment javaComment

if !exists("did_java_syntax_inits")
  let did_java_syntax_inits = 1
  " The default methods for highlighting.  Can be overridden later
  highlight link javaBranch	javaStatement
  highlight link javaLabel	javaStatement
  highlight link javaConditional	javaStatement
  highlight link javaRepeat 	javaStatement
  highlight link javaStructure 	javaStatement
  highlight link javaExceptions javaStatement
  highlight link javaStorageClass	javaDeclarative
  highlight link javaMethodDecl javaDeclarative
  highlight link javaClassDecl 	javaDeclarative
  highlight link javaScopeDecl 	javaDeclarative
  highlight link javaBoolValue 	javaValue
  highlight link javaSpecial 	javaValue
  highlight link javaString 	String
  highlight link javaCharacter	Character
  highlight link javaSpecialCharacter	javaValue
  highlight link javaNumber 	javaValue
  highlight link javaError	Error
  highlight link javaStatement	Statement
  highlight link javaOperator	Statement
  highlight link javaComment	Comment
  highlight link javaLineComment	Comment
  highlight link javaType	Type
  highlight link javaValue	Number
  highlight link javaDeclarative	Special
  highlight link javaExternal	PreCondit
endif
