" Vim syntax file
" Language:	MSDOS batch file
" Maintainer:	Mario Eusebio <bio@dq.fct.unl.pt>
" Last change:	1997 April 20

" Remove any old syntax stuff hanging around
syntax clear

syntax case ignore

syntax keyword dosbatchStatement	call echo off
syntax keyword dosbatchLabel		goto in
syntax keyword dosbatchConditional	if not errorlevel exist
syntax keyword dosbatchRepeat	        for do
syntax keyword dosbatchCommands		command set cls cd copy xcopy del
syntax keyword dosbatchCommands		move ren md rd path

syntax keyword dosbatchTodo contained	TODO

" String 
syntax region  dosbatchString	  start=+"+  end=+"+

"syntax match  dosbatchIdentifier	"\<[a-zA-Z_][a-zA-Z0-9_]*\>"

" If you don't like tabs
"syntax match dosbatchShowTab "\t"
"syntax match dosbatchShowTabc "\t"
" syntax match  dosbatchComment		"^\ \+rem.*" contains dosbatchTodo dosbatchShowTabc
" syntax match  dosbatchComment		"^rem.*" contains dosbatchTodo dosbatchShowTabc

" Some people use this as a comment line but in fact this is 
" a Label
"syntax match  dosbatchComment		"^:\ \+.*" contains dosbatchTodo
"syntax match  dosbatchComment		"^\ \+:\ \+.*" contains dosbatchTodo

syntax match  dosbatchComment		"^rem.*" contains dosbatchTodo
syntax match  dosbatchComment		"^\ \+rem.*" contains dosbatchTodo
syntax match  dosbatchComment		"^::.*" contains dosbatchTodo
syntax match  dosbatchComment		"^\ \+::.*" contains dosbatchTodo

syntax match dosbatchLabelMark         "^:[0-9a-zA-Z_\-]\+\>"
syntax match dosbatchLabelMark         "^\ \+:[0-9a-zA-Z_\-]\+\>"

" this is also a valid Label. I don't use it.
"syntax match dosbatchLabelMark         "^\ \+:\ \+[0-9a-zA-Z_\-]\+\>"
"syntax match dosbatchLabelMark         "^:\ \+[0-9a-zA-Z_\-]\+\>"

syntax match dosbatchVariable         "%[0-9a-z_\-]%"
syntax match dosbatchArgument         "%[0-9]"
syntax match dosbatchArgument         "%%[a-zA-Z]"

" synchronizing
syntax sync lines 100
"syntax sync ccomment dosbatchComment

if !exists("did_dosbatch_syntax_inits")
  let did_dosbatch_syntax_inits = 1
  " The default methods for highlighting.  Can be overridden later
  highlight link dosbatchStatement              dosbatchStatement
  highlight link dosbatchLabel                  Type
  highlight link dosbatchLabelMark              Type
  highlight link dosbatchConditional            dosbatchStatement
  highlight link dosbatchRepeat                 dosbatchStatement
  highlight link dosbatchCommands               dosbatchStatement
  highlight link dosbatchTodo                   Todo
  highlight link dosbatchString                 String
  highlight link dosbatchComment                Comment
  highlight link dosbatchArgument               Identifier
  highlight link dosbatchVariable               Identifier
  highlight link dosbatchStatement              Statement

"optional highlighting
  "highlight link dosbatchShowTab                 Error
  "highlight link dosbatchShowTabc                Error

  "highlight link dosbatchIdentifier	        Identifier
endif
