" Vim syntax support file
" Maintainer:	Bram Moolenaar <mool@oce.nl>
" Last change:	1997 April 20

" This file is called by an autocommand for every file that has just been
" loaded into a buffer.  It checks if the first line of the file is recognized
" as a file for which syntax highlighting is supported.  Only do this if there
" was no match with a filename extension.

if !exists("has_syntax_items")

  " Bourne-like shell scripts: sh ksh
  if getline(1) =~ "^#!.*/k\\=sh\\>"
    source <sfile>:p:h/sh.vim

  " Perl
  elseif getline(1) =~ "^#!.*/k\\=perl[^/]*\\>"
    source <sfile>:p:h/perl.vim

  " Vim scripts (must have " vim as the first line to trigger this)
  elseif getline(1) =~ "^\" *[vV]im$"
    source <sfile>:p:h/vim.vim

  endif
endif
