" Vim syntax file
" Language:	Verilog
" Maintainer:	Mun Johl <mj@core.rose.hp.com>
" Last change:	1997 April 20

" Remove any old syntax stuff hanging around
syntax clear

" A bunch of useful Verilog keywords
syntax keyword verilogStatement     disable assign deassign force release
syntax keyword verilogStatement     parameter function endfunction
syntax keyword verilogStatement     always initial module endmodule
syntax keyword verilogStatement     task endtask
syntax keyword verilogStatement     input output inout reg wire
syntax keyword verilogStatement     posedge negedge wait
syntax keyword verilogLabel         begin end
syntax keyword verilogConditional   if else case casex casez default endcase
"syntax keyword verilogConditional   ? :
syntax keyword verilogRepeat        forever repeat while for
"syntax keyword verilogUnaryOperator ! ~ & ~& | ^| ^ ~^
"syntax keyword verilogBinaryOperator + - * / % == != === !== && || < <= > >=
"syntax keyword verilogBinaryOperator >> << ^~

syntax keyword verilogTodo contained    TODO

" String and Character contstants
" Highlight special characters (those which have a backslash) differently
syntax region  verilogString  start=+"+  end=+"+

syntax match   verilogNumber  "\<[0-9]\+'[bdh][0-9a-fA-F]\+\>"
syntax match   verilogNumber  "\<[0-9]\+\>"

syntax match  verilogConstant "\<[A-Z][A-Z0-9_]\+"

syntax match  verilogGlobal    "\<\$[a-z]\+\>"

syntax region verilogComment  start="/\*" end="\*/"
syntax match  verilogComment  "//.*"
syntax match  verilogComment  "^[ ]*\*.*" contains verilogTodo

syntax match verilogOperator "[&|~><!)(#%@+=?:;.\^\-\[\]]"

if !exists("did_verilog_syntax_inits")
  let did_verilog_syntax_inits = 1
  " The default methods for highlighting.  Can be overridden later

 "highlight link verilogBinaryOperator    Operator
  highlight link verilogCharacter   Character
 "highlight link verilogComment Comment
  highlight link verilogConditional verilogStatement
 "highlight link verilogLabel       Label
 "highlight link verilogNumber  Number
  highlight link verilogRepeat  verilogStatement
 "highlight link verilogStatement   Statement
  highlight link verilogString  String
  highlight link verilogTodo        Todo

  highlight verilogComment Comment
  highlight verilogConstant Constant
  highlight verilogLabel Label
  highlight verilogNumber Number
  highlight verilogOperator Operator
  highlight verilogStatement Statement
  highlight verilogGlobal Special
endif
