/* config.h.  Generated automatically by configure.  */
/* $Id: config.h.in,v 1.6 1997/04/05 06:38:34 darren Exp $   */
/*----------------------------------------------------------------------------
 *  User customization section
 *--------------------------------------------------------------------------*/

/*  Define this label if the const keyword is not supported (or is improperly
 *  implemented) by your compiler.
 */
/* #undef const */

/*  Define this label if you have <stdlib.h>.
 */
#define HAVE_STDLIB_H 1

/*  Define this label if you have <unistd.h>.
 */
#define HAVE_UNISTD_H 1

/*  Define this label if <limits.h> causes PATH_MAX to be defined.
 */
#define INCLUDE_LIMITS_H 1

/*  Define this label if <limits.h> does not define PATH_MAX, but <dirent.h>
 *  causes MAXNAMLEN to be defined.
 */
/* #undef INCLUDE_DIRENT_H */

/*  Define this label to use the system sort utility (which is probably more
 *  efficient) over the interal sorting algorithm.
 */
#define EXTERNAL_SORT 1

/*  If you are using the system sort utility (i.e. external sort), define this
 *  label to be the name of your awk program, which is used for report
 *  duplicate tags when the -W option is specified.
 */
#define AWK "awk"

/*  If you do not have the library call remove(), define this label
 */
/* #undef NO_REMOVE */

/*----------------------------------------------------------------------------
 *  You should not need to change anything below this line
 *--------------------------------------------------------------------------*/
#include <stdio.h>	/* to define FILE and SEEK_SET */

#ifndef SEEK_SET
# define SEEK_SET 0
#endif

/*  This defines the replacement for the remove() library call.
 */
#ifdef NO_REMOVE
# ifdef HAVE_UNISTD_H
#  include <unistd.h>	    /* to declare unlink() */
# endif
# define remove(fname)	unlink(fname)
#endif

/*----------------------------------------------------------------------------
 *  Potentially missing prototypes
 *--------------------------------------------------------------------------*/

/* #undef NEED_PROTO_REMOVE */
/* #undef NEED_PROTO_UNLINK */
/* #undef NEED_PROTO_MALLOC */
/* #undef NEED_PROTO_FREE */
/* #undef NEED_PROTO_GETENV */
/* #undef NEED_PROTO_SSCANF */
/* #undef NEED_PROTO_PERROR */
/* #undef NEED_PROTO_SYSTEM */

/* #undef NEED_PROTO_UNGETC */
/* #undef NEED_PROTO_FCLOSE */
/* #undef NEED_PROTO_FPUTC */
/* #undef NEED_PROTO_FPUTS */
/* #undef NEED_PROTO_FPRINTF */
/* #undef NEED_PROTO_FSCANF */
/* #undef NEED_PROTO_FSEEK */
/* #undef NEED_PROTO_REWIND */
/* #undef NEED_PROTO__FILBUF */
/* #undef NEED_PROTO__FLSBUF */
/* #undef NEED_PROTO_STAT */

/*  Determine whether to use prototypes or simple declarations.
 */
#ifndef __ARGS 
# if defined(__STDC__) || defined(WIN32)
#  define __ARGS(x) x
#  define USING_PROTOTYPES
# else
#  define __ARGS(x) ()
/* #  undef USING_PROTOTYPES */
# endif
#endif

#if defined(NEED_PROTO_REMOVE) && !defined(NO_REMOVE) 
extern int remove __ARGS((const char *));
#endif
#if defined(NEED_PROTO_UNLINK) && defined(NO_REMOVE)
extern void *unlink __ARGS((const char *));
#endif
#ifdef NEED_PROTO_MALLOC
extern void *malloc __ARGS((size_t));
#endif
#ifdef NEED_PROTO_FREE
extern void free __ARGS((void));
#endif
#ifdef NEED_PROTO_GETENV
extern char *getenv __ARGS((const char *));
#endif
#ifdef NEED_PROTO_SSCANF
extern int sscanf __ARGS((const char *, const char *, ...));
#endif
#ifdef NEED_PROTO_PERROR
extern void perror __ARGS((const char *));
#endif
#ifdef NEED_PROTO_SYSTEM
extern int system __ARGS((const char *));
#endif
#ifdef NEED_PROTO_STRSTR
extern char *strstr __ARGS((const char *str, const char *substr));
#endif


#ifdef NEED_PROTO_UNGETC
extern int ungetc __ARGS((int, FILE *));
#endif
#ifdef NEED_PROTO_FCLOSE
extern int fclose __ARGS((FILE *));
#endif
#ifdef NEED_PROTO_FPUTC
extern int fputc __ARGS((int, FILE *));
#endif
#ifdef NEED_PROTO_FPUTS
extern int fputs __ARGS((const char *, FILE *));
#endif
#ifdef NEED_PROTO_FPRINTF
extern int fprintf __ARGS((FILE *, const char *, ...));
#endif
#ifdef NEED_PROTO_FSCANF
extern int fscanf __ARGS((FILE *, const char *, ...));
#endif
#ifdef NEED_PROTO_FSEEK
extern int fseek __ARGS((FILE *, long, int));
#endif
#ifdef NEED_PROTO_REWIND
extern int rewind __ARGS((FILE *));
#endif
#ifdef NEED_PROTO__FILBUF
extern int _filbuf __ARGS((FILE *));
#endif
#ifdef NEED_PROTO__FLSBUF
extern int _flsbuf __ARGS((unsigned char, FILE *));
#endif
#ifdef NEED_PROTO_STAT
# include <sys/types.h>
# include <sys/stat.h>
int stat __ARGS((const char *, struct stat *));
#endif

/* vi:set ts=8 sw=4: */
