/* vi:set ts=4 sw=4:
 *
 * VIM - Vi IMproved		by Bram Moolenaar
 *
 * Do ":help uganda"  in Vim to read copying and usage conditions.
 * Do ":help credits" in Vim to see a list of people who contributed.
 */

/*
 * proto.h: include the (automatically generated) function prototypes
 *
 * the proto/xxx.pro files are automatically generated when using Manx/Aztec C.
 * For other compilers you will have to edit them.
 */

/*
 * don't include these while generating prototypes, prevents problems when
 * files are missing
 */
#ifndef PROTO

/*
 * Machine-dependent routines.
 */
# ifdef AMIGA
#  include "proto/os_amiga.pro"
# endif
# if defined(UNIX) || defined(__EMX__)
#  include "proto/os_unix.pro"
#  ifndef HAVE_RENAME
	int rename __PARMS((const char *, const char *));
#  endif
# endif
# ifdef MSDOS
#  include "proto/os_msdos.pro"
# endif
# ifdef WIN32
#  include "proto/os_win32.pro"
# endif
# ifdef VMS
#  include "proto/os_vms.pro"
# endif

# include "proto/buffer.pro"
# include "proto/charset.pro"
# include "proto/digraph.pro"
# include "proto/edit.pro"
# include "proto/eval.pro"
# include "proto/ex_cmds.pro"
# include "proto/ex_docmd.pro"
# include "proto/ex_getln.pro"
# include "proto/fileio.pro"
# include "proto/getchar.pro"
# include "proto/main.pro"
# include "proto/mark.pro"
# ifndef MESSAGE
void smsg __PARMS((char_u *, ...));	/* cannot be produced automatically */
void smsg_attr __PARMS((int, char_u *, ...));
# endif
# include "proto/memfile.pro"
# include "proto/memline.pro"
# include "proto/message.pro"
# include "proto/misc1.pro"
# include "proto/misc2.pro"
# include "proto/normal.pro"
# include "proto/ops.pro"
# include "proto/option.pro"
# include "proto/quickfix.pro"
# include "proto/regexp.pro"
# include "proto/screen.pro"
# include "proto/search.pro"
# include "proto/syntax.pro"
# include "proto/tag.pro"
# include "proto/term.pro"
# if defined(HAVE_TGETENT) && (defined(AMIGA) || defined(VMS))
#  include "proto/termlib.pro"
# endif
# include "proto/ui.pro"
# include "proto/undo.pro"
# include "proto/version.pro"
# include "proto/window.pro"

# ifdef HAVE_PYTHON
#  include "proto/if_python.pro"
# endif

# ifdef USE_GUI
#  include "proto/gui.pro"
#  ifdef USE_GUI_WIN32
#   include "proto/gui_w32.pro"
#  endif
#  ifdef USE_GUI_MOTIF
#   include "proto/gui_motif.pro"
#  endif
#  ifdef USE_GUI_ATHENA
#   include "proto/gui_athena.pro"
#  endif
#  ifdef USE_GUI_X11
#   include "proto/gui_x11.pro"
#   if !defined(HAVE_SETENV) && !defined(HAVE_PUTENV)
extern int putenv __ARGS((char *string));		/* from pty.c */
#   endif
extern int OpenPTY __ARGS((char **ttyn));		/* from pty.c */
#  endif
# endif	/* USE_GUI */

/*
 * The perl include files pollute the namespace, therfore proto.h must be
 * included before the perl include files.  But then CV is not defined, which
 * is used in if_perl.pro.  To get around this, the perl prototype files are
 * not included here for the perl files.  Use a dummy define for CV for the
 * other files.
 */
#if defined(HAVE_PERL_INTERP) && !defined(IN_PERL_FILE)
#   define CV void
# include "proto/if_perl.pro"
# include "proto/if_perlsfio.pro"
#endif

#endif /* PROTO */
