" Vim syntax file
" Language:	C++
" Maintainer:	?
" Last change:	1997 April 20

" Remove any old syntax stuff hanging around
syntax clear

" Read the C syntax to start with
source <sfile>:p:h/c.vim

" C++ extentions

syntax keyword cppStatement	new delete this
syntax keyword cppStatement	template operator friend
syntax keyword cppScopeDecl	public protected private
syntax keyword cppType		inline virtual
syntax keyword cppExceptions	throw try catch
syntax keyword cppCast		const_cast static_cast explicit

syntax match cppClassPreDecl	"^[ 	]*class[ 	][ 	]*[a-zA-Z_][a-zA-Z0-9_]*[ 	]*;" 
syntax match cppClassDecl	"^[ 	]*class[ 	][ 	]*[a-zA-Z_][a-zA-Z0-9_]*"

" Functions ... 
syntax match cppFunction  "^[a-zA-Z][^ 	(]*("e-1
syntax match cppMethod  "^[a-zA-Z][a-zA-Z0-9_]*::[^(]*("e-1

if !exists("did_cpp_syntax_inits")
  let did_cpp_syntax_inits = 1
  highlight link cppClassDecl	cppType
  highlight link cppClassPreDecl	cppStatement
  highlight link cppScopeDecl	cppStatement
  highlight link cppCast	cppStatement
  highlight link cppExceptions	cppStatement
  highlight link cppMethod	cppFunction
  highlight link cppStatement	Statement
  highlight link cppType	Type
  highlight link cppMethod	Function
  highlight link cppFunction	Function
endif
