" Vim syntax file
" Language:	PostScript
" Maintainer:	Mario Eusebio <bio@dq.fct.unl.pt>
" Last change:	1997 April 20

" Remove any old syntax stuff hanging around
syntax clear

syntax case match

syntax keyword postscrTodo contained	TODO

" String 
syntax region  postscrString	  start=+(+  end=+)+

syntax match  postscrDelimiter	"[{}]"

syntax match  postscrComment		"%.*" contains postscrTodo

syntax keyword postscrFunction    add aload and arc arcn arcto array
syntax keyword postscrFunction    ashow awidthshow begin charpath
syntax keyword postscrFunction    clear closepath copy copy copypage
syntax keyword postscrFunction    def definefont dict div dup end eq
syntax keyword postscrFunction    exch exec exit false fill findfont
syntax keyword postscrFunction    for forall ge get grestore gsave
syntax keyword postscrFunction    gt idiv if ifelse kshow le length
syntax keyword postscrFunction    lineto loop lt makefont maxlength
syntax keyword postscrFunction    moveto mul ne neg newpath not or
syntax keyword postscrFunction    pop put repeat restore rlineto
syntax keyword postscrFunction    rmoveto roll rotate round save
syntax keyword postscrFunction    scale search setgray setlinewidth
syntax keyword postscrFunction    show showpage keyword string stroke
syntax keyword postscrFunction    sub translate true widthshow xor

"syntax sync ccomment postscrComment
syntax sync lines 100

if !exists("did_postscr_syntax_inits")
  let did_postscr_syntax_inits = 1
  " The default methods for highlighting.  Can be overridden later
  highlight link postscrTodo                     Todo
  highlight link postscrString                   String
  highlight link postscrFunction                 Statement
  highlight link postscrComment                  Comment
  highlight link postscrDelimiter                Identifier
endif
