/* nevars.h: this header file was produced automatically by
 * the mktbls program, based on input from the file ./modetbl
 */

#if OPT_EVAL

/*	structure to hold user variables and their definitions	*/

typedef struct UVAR {
	struct UVAR *next;
	char *u_name;		/* name of user variable */
	char *u_value;				/* value (string) */
} UVAR;

decl_uninit( UVAR *user_vars );	/* user variables */


/*	list of recognized environment variables	*/

#ifdef realdef
const char *const envars[] = {
	s_abufname__,
#if OPT_PROCEDURES
	s_buffer_hook__,
#endif
	s_cbufname__,
#if OPT_PROCEDURES
	s_cd_hook__,
#endif
	s_cfilname__,
	s_char__,
#if OPT_ENCRYPT
	s_cryptkey__,
#endif
	s_curcol__,
	s_curline__,
	s_cwd__,
	s_cwline__,
	s_debug__,
	s_directory__,
	s_discmd__,
	s_disinp__,
#if OPT_PROCEDURES
	s_exit_hook__,
#endif
	s_flicker__,
#if DISP_X11
	s_font__,
#endif
	s_forward_search__,
	s_helpfile__,
#if DISP_X11
	s_iconname__,
#endif
	s_identifier__,
	s_kill__,
	s_lastkey__,
	s_line__,
	s_llength__,
	s_match__,
	s_mode__,
#if OPT_MLFORMAT
	s_modeline_format__,
#endif
	s_modified__,
	s_ntildes__,
	s_ocwd__,
	s_os__,
	s_pagelen__,
	s_pagewid__,
	s_palette__,
	s_pathname__,
	s_pending__,
	s_pid__,
	s_progname__,
	s_qidentifier__,
#if OPT_RAMSIZE
	s_ram__,
#endif
#if OPT_PROCEDURES
	s_read_hook__,
#endif
	s_replace__,
	s_search__,
	s_seed__,
	s_shell__,
	s_sres__,
	s_startup_file__,
	s_startup_path__,
	s_status__,
#if DISP_X11
	s_title__,
#endif
	s_tpause__,
	s_version__,
	s_wline__,
	s_word__,
#if OPT_PROCEDURES
	s_write_hook__,
#endif
	NULL	/* ends table for name-completion */
};
#else
extern const char *const envars[];
#endif

/* 	and its preprocesor definitions		*/

typedef	struct	{
	char	s_abufname__;	/* alternate buffer name (i.e. '#') */
#if OPT_PROCEDURES
	char	s_buffer_hook__; /* procedure to run when entering buf */
#endif
	char	s_cbufname__;	/* current buffer name */
#if OPT_PROCEDURES
	char	s_cd_hook__;	/* procedure to run when cd'ing */
#endif
	char	s_cfilname__;	/* current file name */
	char	s_char__;	/* current character under the cursor */
#if OPT_ENCRYPT
	char	s_cryptkey__;	/* write-only encryption-key */
#endif
	char	s_curcol__;	/* current column pos of cursor */
	char	s_curline__;	/* current line in file */
	char	s_cwd__;	/* current directory */
	char	s_cwline__;	/* current screen line in window */
	char	s_debug__;	/* macro debugging */
	char	s_directory__;	/* controls location of temp-files */
	char	s_discmd__;	/* display commands on command line */
	char	s_disinp__;	/* display command line input characters */
#if OPT_PROCEDURES
	char	s_exit_hook__;	/* procedure to run when quitting */
#endif
	char	s_flicker__;	/* flicker suppression */
#if DISP_X11
	char	s_font__;	/* current font */
#endif
	char	s_forward_search__; /* search-direction (true if forward) */
	char	s_helpfile__;	/* helpfile (vile.hlp) */
#if DISP_X11
	char	s_iconname__;	/* current font */
#endif
	char	s_identifier__; /* current identifier */
	char	s_kill__;	/* kill buffer (read only) */
	char	s_lastkey__;	/* last keyboard char struck */
	char	s_line__;	/* text of current line */
	char	s_llength__;	/* length of current line */
	char	s_match__;	/* last matched magic pattern */
	char	s_mode__;	/* are we inserting/overwriting/command */
#if OPT_MLFORMAT
	char	s_modeline_format__; /* modeline format string */
#endif
	char	s_modified__;	/* is current buffer modified? */
	char	s_ntildes__;	/* number of tildes displayed at eob */
	char	s_ocwd__;	/* previous directory */
	char	s_os__;		/* what os are we on? */
	char	s_pagelen__;	/* number of lines used by editor */
	char	s_pagewid__;	/* current screen width */
	char	s_palette__;	/* current palette string */
	char	s_pathname__;	/* current path-like word */
	char	s_pending__;	/* type ahead pending flag */
	char	s_pid__;	/* vile's process-id */
	char	s_progname__;	/* returns current prog name - "vile" */
	char	s_qidentifier__; /* current qualified identifier */
#if OPT_RAMSIZE
	char	s_ram__;	/* ram in use by malloc */
#endif
#if OPT_PROCEDURES
	char	s_read_hook__;	/* procedure to run when reading */
#endif
	char	s_replace__;	/* replacement pattern */
	char	s_search__;	/* search pattern */
	char	s_seed__;	/* current random number seed */
	char	s_shell__;	/* shell-environment variable */
	char	s_sres__;	/* current screen resolution */
	char	s_startup_file__; /* the name of the startup-file (e.g., .vilerc) */
	char	s_startup_path__; /* where to find the startup-file (e.g., .) */
	char	s_status__;	/* returns the status of the last command */
#if DISP_X11
	char	s_title__;	/* window title */
#endif
	char	s_tpause__;	/* length to pause for paren matching */
	char	s_version__;	/* current version number */
	char	s_wline__;	/* # of lines in current window */
	char	s_word__;	/* current word */
#if OPT_PROCEDURES
	char	s_write_hook__; /* procedure to run when writing */
#endif
	char	s_MAX;
	char	Q1;
	} IndexVars;

#define	EVABUFNAME	Member_Offset(IndexVars, s_abufname__)
#if OPT_PROCEDURES
#define	EVBUFHOOK	Member_Offset(IndexVars, s_buffer_hook__)
#endif
#define	EVCBUFNAME	Member_Offset(IndexVars, s_cbufname__)
#if OPT_PROCEDURES
#define	EVCDHOOK	Member_Offset(IndexVars, s_cd_hook__)
#endif
#define	EVCFNAME	Member_Offset(IndexVars, s_cfilname__)
#define	EVCURCHAR	Member_Offset(IndexVars, s_char__)
#if OPT_ENCRYPT
#define	EVCRYPTKEY	Member_Offset(IndexVars, s_cryptkey__)
#endif
#define	EVCURCOL	Member_Offset(IndexVars, s_curcol__)
#define	EVCURLINE	Member_Offset(IndexVars, s_curline__)
#define	EVCWD		Member_Offset(IndexVars, s_cwd__)
#define	EVCWLINE	Member_Offset(IndexVars, s_cwline__)
#define	EVDEBUG		Member_Offset(IndexVars, s_debug__)
#define	EVDIRECTORY	Member_Offset(IndexVars, s_directory__)
#define	EVDISCMD	Member_Offset(IndexVars, s_discmd__)
#define	EVDISINP	Member_Offset(IndexVars, s_disinp__)
#if OPT_PROCEDURES
#define	EVEXITHOOK	Member_Offset(IndexVars, s_exit_hook__)
#endif
#define	EVFLICKER	Member_Offset(IndexVars, s_flicker__)
#if DISP_X11
#define	EVFONT		Member_Offset(IndexVars, s_font__)
#endif
#define	EVFWD_SEARCH	Member_Offset(IndexVars, s_forward_search__)
#define	EVHELPFILE	Member_Offset(IndexVars, s_helpfile__)
#if DISP_X11
#define	EVICONNAM	Member_Offset(IndexVars, s_iconname__)
#endif
#define	EVIDENTIF	Member_Offset(IndexVars, s_identifier__)
#define	EVKILL		Member_Offset(IndexVars, s_kill__)
#define	EVLASTKEY	Member_Offset(IndexVars, s_lastkey__)
#define	EVLINE		Member_Offset(IndexVars, s_line__)
#define	EVLLENGTH	Member_Offset(IndexVars, s_llength__)
#define	EVMATCH		Member_Offset(IndexVars, s_match__)
#define	EVMODE		Member_Offset(IndexVars, s_mode__)
#if OPT_MLFORMAT
#define	EVMLFORMAT	Member_Offset(IndexVars, s_modeline_format__)
#endif
#define	EVMODIFIED	Member_Offset(IndexVars, s_modified__)
#define	EVNTILDES	Member_Offset(IndexVars, s_ntildes__)
#define	EVOCWD		Member_Offset(IndexVars, s_ocwd__)
#define	EVOS		Member_Offset(IndexVars, s_os__)
#define	EVPAGELEN	Member_Offset(IndexVars, s_pagelen__)
#define	EVCURWIDTH	Member_Offset(IndexVars, s_pagewid__)
#define	EVPALETTE	Member_Offset(IndexVars, s_palette__)
#define	EVPATHNAME	Member_Offset(IndexVars, s_pathname__)
#define	EVPENDING	Member_Offset(IndexVars, s_pending__)
#define	EVPROCESSID	Member_Offset(IndexVars, s_pid__)
#define	EVPROGNAME	Member_Offset(IndexVars, s_progname__)
#define	EVQIDENTIF	Member_Offset(IndexVars, s_qidentifier__)
#if OPT_RAMSIZE
#define	EVRAM		Member_Offset(IndexVars, s_ram__)
#endif
#if OPT_PROCEDURES
#define	EVRDHOOK	Member_Offset(IndexVars, s_read_hook__)
#endif
#define	EVREPLACE	Member_Offset(IndexVars, s_replace__)
#define	EVSEARCH	Member_Offset(IndexVars, s_search__)
#define	EVSEED		Member_Offset(IndexVars, s_seed__)
#define	EVSHELL		Member_Offset(IndexVars, s_shell__)
#define	EVSRES		Member_Offset(IndexVars, s_sres__)
#define	EVSTARTUP_FILE	Member_Offset(IndexVars, s_startup_file__)
#define	EVSTARTUP_PATH	Member_Offset(IndexVars, s_startup_path__)
#define	EVSTATUS	Member_Offset(IndexVars, s_status__)
#if DISP_X11
#define	EVTITLE		Member_Offset(IndexVars, s_title__)
#endif
#define	EVTPAUSE	Member_Offset(IndexVars, s_tpause__)
#define	EVVERSION	Member_Offset(IndexVars, s_version__)
#define	EVWLINE		Member_Offset(IndexVars, s_wline__)
#define	EVWORD		Member_Offset(IndexVars, s_word__)
#if OPT_PROCEDURES
#define	EVWRHOOK	Member_Offset(IndexVars, s_write_hook__)
#endif

/*	list of recognized user functions	*/

typedef struct UFUNC {
	char *f_name;	/* name of function */
	int f_type;	/* 1 = monamic, 2 = dynamic */
} UFUNC;

#define	NILNAMIC	0
#define	MONAMIC		1
#define	DYNAMIC		2
#define	TRINAMIC	3

#ifdef realdef
const UFUNC funcs[] = {
	{"abs", MONAMIC},	/* absolute value of a number */
	{"add", DYNAMIC},	/* add two numbers together */
	{"and", DYNAMIC},	/* logical and */
	{"asc", MONAMIC},	/* char to integer conversion */
	{"bin", MONAMIC},	/* lookup what function name is bound to a key */
	{"cat", DYNAMIC},	/* concatenate string */
	{"chr", MONAMIC},	/* integer to char conversion */
	{"div", DYNAMIC},	/* division */
	{"env", MONAMIC},	/* retrieve a system environment var */
	{"equ", DYNAMIC},	/* logical equality check */
	{"glo", MONAMIC},	/* retrieve global setting */
	{"gre", DYNAMIC},	/* logical greater than */
	{"gtk", NILNAMIC},	/* get 1 character */
	{"ind", MONAMIC},	/* evaluate indirect value */
	{"lef", DYNAMIC},	/* left string(string, len) */
	{"len", MONAMIC},	/* string length */
	{"les", DYNAMIC},	/* logical less than */
	{"loc", MONAMIC},	/* retrieve local setting */
	{"low", MONAMIC},	/* lower case string */
	{"mid", TRINAMIC},	/* mid string(string, pos, len) */
	{"mod", DYNAMIC},	/* modulo */
	{"neg", MONAMIC},	/* negate */
	{"not", MONAMIC},	/* logical not */
	{"or", DYNAMIC},	/* logical or */
	{"rd", MONAMIC},	/* is a file readable? */
	{"rig", DYNAMIC},	/* right string(string, pos) */
	{"rnd", MONAMIC},	/* get a random number */
	{"seq", DYNAMIC},	/* string logical equality check */
	{"sgr", DYNAMIC},	/* string logical greater than */
	{"sin", DYNAMIC},	/* find the index of one string in another */
	{"sle", DYNAMIC},	/* string logical less than */
	{"sub", DYNAMIC},	/* subtraction */
	{"tim", DYNAMIC},	/* multiplication */
	{"tri", MONAMIC},	/* trims leading/trailing/repeated whitespace */
	{"tru", MONAMIC},	/* Truth of the universe logical test */
	{"upp", MONAMIC},	/* uppercase string */
	{"wr", MONAMIC},	/* is a file writeable? */
};
#else
extern const UFUNC funcs[];
#endif

/* 	and its preprocesor definitions		*/

#define	UFABS		0
#define	UFADD		1
#define	UFAND		2
#define	UFASCII		3
#define	UFBIND		4
#define	UFCAT		5
#define	UFCHR		6
#define	UFDIV		7
#define	UFENV		8
#define	UFEQUAL		9
#define	UFGLOBMODE	10
#define	UFGREATER	11
#define	UFGTKEY		12
#define	UFIND		13
#define	UFLEFT		14
#define	UFLENGTH	15
#define	UFLESS		16
#define	UFLOCMODE	17
#define	UFLOWER		18
#define	UFMID		19
#define	UFMOD		20
#define	UFNEG		21
#define	UFNOT		22
#define	UFOR		23
#define	UFREADABLE	24
#define	UFRIGHT		25
#define	UFRND		26
#define	UFSEQUAL	27
#define	UFSGREAT	28
#define	UFSINDEX	29
#define	UFSLESS		30
#define	UFSUB		31
#define	UFTIMES		32
#define	UFTRIM		33
#define	UFTRUTH		34
#define	UFUPPER		35
#define	UFWRITABLE	36

#define	NFUNCS		37

#endif /* OPT_EVAL */
